require = GLOBAL.require
GetPlayer = GLOBAL.GetPlayer
GetWorld = GLOBAL.GetWorld
TUNING = GLOBAL.TUNING
Vector3 = GLOBAL.Vector3
GetClock = GLOBAL.GetClock
SpawnPrefab = GLOBAL.SpawnPrefab

if GetModConfigData("bgsenabled")==true then
require("debugkeys")
local MainScreen = require "screens/mainscreen"
local myedit = MainScreen.DoInit
function MainScreen:DoInit()
	local asdf = myedit(self)
	self.bg:SetTint(2/3, 0, 0, 1.0)
	return asdf
end
local OptionsScreen = require "screens/optionsscreen"
local myedit = OptionsScreen.DoInit
function OptionsScreen:DoInit()
	local asdf = myedit(self)
	self.bg:SetTint(2/3, 0, 0, 1.0)
	return asdf
end
local WorldGenScreen = require "screens/worldgenscreen"
local myedit = WorldGenScreen.OnUpdate
function WorldGenScreen:OnUpdate(dt)
	local asdf = myedit(self,dt)
	self.bg:SetTint(2/3, 0, 0, 1.0)
	return asdf
end
local ControlsScreen = require "screens/controlsscreen"
local myedit = ControlsScreen.RefreshControls
function ControlsScreen:RefreshControls()
	local asdf = myedit(self)
	self.bg:SetTint(2/3, 0, 0, 1.0)
	return asdf
end
local CharacterSelectScreen = require "screens/characterselectscreen"
local myedit = CharacterSelectScreen.SelectPortrait
function CharacterSelectScreen:SelectPortrait(portrait)
	local asdf = myedit(self,portrait)
	self.bg:SetTint(2/3, 0, 0, 1.0)
	return asdf
end
local BroadcastingOptionsScreen = require "screens/broadcastingoptionsscreen"
local myedit = BroadcastingOptionsScreen.DoInit
function BroadcastingOptionsScreen:DoInit()
	local asdf = myedit(self)
	self.bg:SetTint(2/3, 0, 0, 1.0)
	return asdf
end
local MorgueScreen = require "screens/morguescreen"
local myedit = MorgueScreen.OnBecomeActive
function MorgueScreen:OnBecomeActive()
	local asdf = myedit(self)
	self.bg:SetTint(2/3, 0, 0, 1.0)
	return asdf
end
local ModsScreen = require "screens/modsscreen"
local myedit = ModsScreen.ShowModDetails
function ModsScreen:ShowModDetails(idx)
	local asdf = myedit(self,idx)
	self.bg:SetTint(2/3, 0, 0, 1.0)
	return asdf
end
local ModConfigurationScreen = require "screens/modconfigurationscreen"
local myedit = ModConfigurationScreen.RefreshOptions
function ModConfigurationScreen:RefreshOptions()
	local asdf = myedit(self)
	self.bg:SetTint(2/3, 0, 0, 1.0)
	return asdf
end
local CustomizationScreen = require "screens/customizationscreen"
local myedit = CustomizationScreen.RefreshOptions
function CustomizationScreen:RefreshOptions()
	local asdf = myedit(self)
	self.bg:SetTint(2/3, 0, 0, 1.0)
	return asdf
end
end

--speed debuffs
local LocoMotor = require "components/locomotor"
local mylocomotor = LocoMotor.RunForward
function LocoMotor:RunForward()
	local asdf = mylocomotor(self)
	local inst = self.inst
		if inst.prefab == GetPlayer().prefab and GetPlayer().components.health and GetPlayer().components.hunger then

			local health=GetPlayer().components.health.currenthealth/GetPlayer().components.health.maxhealth
			local hunger=GetPlayer().components.hunger.current/GetPlayer().components.hunger.max
			local hungerfactor=1
			local moddedrunspeed=self:GetRunSpeed()*health
			local lowest=self:GetRunSpeed()/6

			if moddedrunspeed < lowest then
				moddedrunspeed=lowest
			end

			if hunger >= .9 then
				hungerfactor=.8
			end
			if hunger < .9 and hunger >= .8 then
				hungerfactor=.85
			end
			if hunger < .8 and hunger >= .7 then
				hungerfactor=.9
			end
			if hunger < .7 and hunger >= .6 then
				hungerfactor=.95
			end
			if hunger < .6 and hunger >= .4 then
				hungerfactor=1
			end
			if hunger < .4 and hunger >= .3 then
				hungerfactor=.9
			end
			if hunger < .3 and hunger >= .2 then
				hungerfactor=.85
			end
			if hunger < .2 and hunger >= .1 then
				hungerfactor=.8
			end
			if hunger < .1 then
				hungerfactor=.75
			end

			moddedrunspeed=moddedrunspeed*hungerfactor
--print("Runspeed: " .. moddedrunspeed)
			self.isrunning = true
			self.inst.Physics:SetMotorVel(moddedrunspeed,0,0)
			self.inst:StartUpdatingComponent(self)

		end
	return asdf
end

--damage debuffs:
local Combat = require "components/combat"
local Combat_CalcDamage_base = Combat.CalcDamage
function Combat:CalcDamage(target, weapon, multiplier)
	local damage = Combat_CalcDamage_base(self, target, weapon, multiplier)
		if self.inst.prefab == GetPlayer().prefab and target ~= GetPlayer() and GetPlayer().components.health and GetPlayer().components.hunger then

			local damagefactor=1
			local health=GetPlayer().components.health.currenthealth/GetPlayer().components.health.maxhealth
			local hunger=GetPlayer().components.hunger.current/GetPlayer().components.hunger.max

			if health > 0 then
				damagefactor=damagefactor*health
				if hunger > 0 then
					damagefactor=damagefactor*hunger
				else
					hunger=.01
					damagefactor=damagefactor*hunger
				end
				if damagefactor <= 0 then
					damagefactor=.01
				end
			end

			damage = damage * damagefactor
--print("Player did " .. damage .. " damage.")
		end
		if target == GetPlayer() then
			local buff=damage*.35
			damage=damage+buff
			local sanitydebuff=damage*.25
			GetPlayer().components.sanity:DoDelta(-sanitydebuff)
--print(GetPlayer().prefab .. " will take " .. damage .. " damage.")
		end
	return damage
end

local function spawnoffscreen(pt, radius)
	local theta = math.random() * 2 * GLOBAL.PI
	radius = radius or 30
	local offset = GLOBAL.FindWalkableOffset(pt, theta, radius, 12, true)
	if offset then
		return pt+offset
	end
end
--combat ready spawner
function spawnattacker(prefab, trytoscale, chancetoscale, trytomega, chancetomega, teleporttoinst, inst)
	teleporttoinst=teleporttoinst or false
	trytoscale=trytoscale or false
	chancetoscale=chancetoscale or 2
	trytomega=trytomega or false
	chancetomega=chancetomega or 3
	local pt = Vector3(GetPlayer().Transform:GetWorldPosition())
	local spawn_pt = spawnoffscreen(pt)
	if spawn_pt and prefab then
		local attacker = SpawnPrefab(prefab)
		if attacker and teleporttoinst==true then
			spawn_pt = Vector3(inst.Transform:GetWorldPosition())
			attacker.Physics:Teleport(spawn_pt:Get())
		end
		if attacker and attacker.Physics and attacker.components.combat then
			attacker:FacePoint(pt)
			attacker.Physics:Teleport(spawn_pt:Get())
			if attacker.components.knownlocations then
				attacker.components.knownlocations.locations["home"]=Vector3(GetPlayer().Transform:GetWorldPosition())
			end
			if attacker.components.sleeper and attacker.components.sleeper.isasleep then
				attacker.components.sleeper:WakeUp()
			end
			if trytoscale==true then
				if math.random(chancetoscale)==1 then
					local scaleamount
					local megaed
					if trytomega==true and math.random(chancetomega)==1 then
						scaleamount=3
						megaed=true
					else
						scaleamount=math.random()
						scaleamount=scaleamount+1
						megaed=false
					end
--print("scale amount: " .. scaleamount)
					attacker.Transform:SetScale(scaleamount,scaleamount,scaleamount)
					if attacker.components.health then
						attacker.components.health.maxhealth=attacker.components.health.maxhealth*scaleamount
						attacker.components.health:DoDelta(attacker.components.health.maxhealth)
					end
					attacker.components.combat.defaultdamage=attacker.components.combat.defaultdamage*scaleamount
					if megaed==true then
						attacker.components.combat.attackrange=attacker.components.combat.attackrange*2
						attacker.components.combat.hitrange=attacker.components.combat.hitrange*2
					else
						attacker.components.combat.attackrange=attacker.components.combat.attackrange*scaleamount
						attacker.components.combat.hitrange=attacker.components.combat.hitrange*scaleamount
					end
					if attacker.components.combat.areahitrange ~= nil then
						if megaed==true then
							attacker.components.combat.areahitrange=attacker.components.combat.areahitrange*2
						else
							attacker.components.combat.areahitrange=attacker.components.combat.areahitrange*scaleamount
						end
					end
				end
			end
			attacker.components.combat:SetTarget(GetPlayer())
		end
	end
end

--hostile mob scaler
local function mobrescaler(inst, chancetoscale, trytomega, chancetomega)
	chancetoscale=chancetoscale or 2
	trytomega=trytomega or true
	chancetomega=chancetomega or 3
	if math.random(chancetoscale)==1 then
		local scaleamount
		local megaed
		if trytomega==true and math.random(chancetomega)==1 then
			scaleamount=3
			megaed=true
		else
			scaleamount=math.random()
			scaleamount=scaleamount+1
			megaed=false
		end
		inst.Transform:SetScale(scaleamount,scaleamount,scaleamount)
		if inst.components.health then
			inst.components.health.maxhealth=inst.components.health.maxhealth*scaleamount
			inst.components.health:DoDelta(inst.components.health.maxhealth)
		end
		inst.components.combat.defaultdamage=inst.components.combat.defaultdamage*scaleamount
		if megaed==true then
			inst.components.combat.attackrange=inst.components.combat.attackrange*2
			inst.components.combat.hitrange=inst.components.combat.hitrange*2
		else
			inst.components.combat.attackrange=inst.components.combat.attackrange*scaleamount
			inst.components.combat.hitrange=inst.components.combat.hitrange*scaleamount
		end
		if inst.components.combat.areahitrange ~= nil then
			if megaed==true then
				inst.components.combat.areahitrange=inst.components.combat.areahitrange*2
			else
				inst.components.combat.areahitrange=inst.components.combat.areahitrange*scaleamount
			end
		end
	end
end
AddPrefabPostInit("butterfly", mobrescaler)
AddPrefabPostInit("bee", mobrescaler)
AddPrefabPostInit("killerbee", mobrescaler)
AddPrefabPostInit("babybeefalo", mobrescaler)
AddPrefabPostInit("bat", mobrescaler)
AddPrefabPostInit("beefalo", mobrescaler)
AddPrefabPostInit("bishop", mobrescaler)
AddPrefabPostInit("bunnyman", mobrescaler)
AddPrefabPostInit("deerclops", mobrescaler)
AddPrefabPostInit("eyeplant", mobrescaler)
AddPrefabPostInit("foliage", mobrescaler)
AddPrefabPostInit("frog", mobrescaler)
AddPrefabPostInit("ghost", mobrescaler)
AddPrefabPostInit("hound", mobrescaler)
AddPrefabPostInit("knight", mobrescaler)
AddPrefabPostInit("koalefant", mobrescaler)
AddPrefabPostInit("krampus", mobrescaler)
AddPrefabPostInit("leif", mobrescaler)
AddPrefabPostInit("lureplant", mobrescaler)
AddPrefabPostInit("merm", mobrescaler)
AddPrefabPostInit("monkey", mobrescaler)
AddPrefabPostInit("penguin", mobrescaler)
AddPrefabPostInit("perd", mobrescaler)
AddPrefabPostInit("pigman", mobrescaler)
AddPrefabPostInit("rabbit", mobrescaler)
AddPrefabPostInit("rocky", mobrescaler)
AddPrefabPostInit("rook", mobrescaler)
AddPrefabPostInit("shadowcreature", mobrescaler)
AddPrefabPostInit("slurper", mobrescaler)
AddPrefabPostInit("slurtle", mobrescaler)
AddPrefabPostInit("smallbird", mobrescaler)
AddPrefabPostInit("spider", mobrescaler)
AddPrefabPostInit("spiderqueen", mobrescaler)
AddPrefabPostInit("tallbird", mobrescaler)
AddPrefabPostInit("tentacle", mobrescaler)
AddPrefabPostInit("walrus", mobrescaler)
AddPrefabPostInit("spider_spitter", mobrescaler)
AddPrefabPostInit("firehound", mobrescaler)
AddPrefabPostInit("icehound", mobrescaler)
AddPrefabPostInit("mosquito", mobrescaler)
AddPrefabPostInit("crawlinghorror", mobrescaler)
AddPrefabPostInit("terrorbeak", mobrescaler)
AddPrefabPostInit("spider_warrior", mobrescaler)
AddPrefabPostInit("teenbird", mobrescaler)
AddPrefabPostInit("crow", mobrescaler)
AddPrefabPostInit("robin", mobrescaler)
AddPrefabPostInit("robin_winter", mobrescaler)


--bleeder effect, charlie insta-kill, resurrect, hunger rate increase, hounds, bots
AddSimPostInit(function(inst)
	GetPlayer():ListenForEvent("oneat", function(inst)
		if math.random(4)==1 then
			if GetPlayer().components.talker then
				GetPlayer().components.talker:Say"Hounds!"
			end
--function spawnattacker(prefab, trytoscale, chancetoscale, trytomega, chancetomega, teleporttoinst, inst)
			spawnattacker("hound", true, 2, false, 4)
--			GetWorld().components.hounded:ReleaseHound()
		end
	end)
	GetPlayer():ListenForEvent("buildstructure", function(inst)
		if math.random(3)==1 then
			if GetPlayer().components.talker then
				GetPlayer().components.talker:Say"Destroyers!"
			end
			SpawnPrefab("poop").Transform:SetPosition(Vector3(GetPlayer().Transform:GetWorldPosition()).x,Vector3(GetPlayer().Transform:GetWorldPosition()).y,Vector3(GetPlayer().Transform:GetWorldPosition()).z)
			local temp=math.random(6)
			if temp==1 then
				spawnattacker("knight", true, 2, false)
			end
			if temp==2 then
				spawnattacker("bishop", true)
			end
			if temp==3 then
				spawnattacker("rook", true, 2, false, 5)
			end
			if temp==4 then
				spawnattacker("knight_nightmare", true, 2, false)
			end
			if temp==5 then
				spawnattacker("bishop_nightmare", true)
			end
			if temp==6 then
				spawnattacker("rook_nightmare", true, 2, false, 5)
			end
		end
	end)
	if GetPlayer() and GetPlayer().components.hunger then
		local newhr=GetPlayer().components.hunger.hungerrate/4
		GetPlayer().components.hunger.hungerrate=GetPlayer().components.hunger.hungerrate+newhr
	end
	GetPlayer():ListenForEvent("resurrect", function(inst)
		if GetPlayer().components.health then
			local temp=GetPlayer().components.health.maxhealth/3
			GetPlayer().components.health.maxhealth=GetPlayer().components.health.maxhealth-temp
			GetPlayer().components.health:DoDelta(0)
			GetPlayer().isbleeding=false
		end
	end)
	GetPlayer():ListenForEvent("attackedbygrue", function(inst)
		if GetPlayer().components.health then
			local temp=GetPlayer().components.health.maxhealth*2
			GetPlayer().components.health:DoDelta(-temp)
		end
	end)
	GetPlayer():ListenForEvent("attacked", function(inst)
		local rand=math.random(3)
		if rand == 1 then
			if GetPlayer().components.talker then
				GetPlayer().components.talker:Say"I'm bleeding!"
			end
			GetPlayer().isbleeding = true
			GetPlayer().isbleedingnotified = true
		end
	end)
	GetPlayer():DoPeriodicTask(1, function(inst)
		if GetPlayer().isbleeding == true and GetPlayer().components.health and GetPlayer().components.sanity then
			GetPlayer().components.health:DoDelta(-2)
			GetPlayer().components.sanity:DoDelta(-1)
		else
			GetPlayer().isbleeding = false
			GetPlayer().isbleedingnotified = false
		end
	end)
	GetPlayer():DoPeriodicTask(5, function(inst)
		if GetPlayer().isbleeding == true and GetPlayer().isbleedingnotified == false and GetPlayer().components.talker then
				GetPlayer().components.talker:Say"I'm still bleeding!\nI need to heal!"
		else
			GetPlayer().isbleedingnotified = false
		end
	end)
end)
--bleeding:stop
local Health = require "components/health"
local ddelta = Health.DoDelta
function Health:DoDelta(amount, overtime, cause, ignore_invincible)
	local asdf = ddelta(self, amount, overtime, cause, ignore_invincible)
		if self.inst.prefab == GetPlayer().prefab then
			if amount >= 5 and GetPlayer().isbleeding == true then
				GetPlayer().isbleeding = false
				if GetPlayer().components.talker then
					GetPlayer().components.talker:Say"The bleeding has stopped!"
				end
			end
		end
	return asdf
end
--resurrect and bleeding:save
local savehealth = Health.OnSave
function Health:OnSave()
	local asdf = savehealth(self)
		if self.inst.prefab == GetPlayer().prefab then
			return
			{
				isbleeding = GetPlayer().isbleeding,
				maxhealth = self.maxhealth,
				health = self.currenthealth,
				penalty = self.penalty > 0 and self.penalty or nil
			}
		end
	return asdf
end
--resurrect and bleeding:load
local loadhealth = Health.OnLoad
function Health:OnLoad(data)
	local asdf = loadhealth(self, data)
		if self.inst.prefab == GetPlayer().prefab then
			if data.maxhealth then
				self.inst.components.health.maxhealth=data.maxhealth
				GetPlayer().components.health:DoDelta(0)
			end
			if data.isbleeding then
				GetPlayer().isbleeding=data.isbleeding
			end
		end
	return asdf
end

--tree tentacle
local function treetent(inst)
	inst:ListenForEvent("workfinished", function(inst)
		if math.random(3)==1 then
			if GetPlayer().components.talker then
				GetPlayer().components.talker:Say"He felt the vibrations!"
			end
			GetPlayer().components.playercontroller:ShakeCamera(GetPlayer(), "FULL", 5, .01, 1, 1)
--function spawnattacker(prefab, trytoscale, chancetoscale, trytomega, chancetomega, teleporttoinst, inst)
			spawnattacker("tentacle", true, 2, false, 1, true, inst)
		end
	end)
end
AddPrefabPostInit("evergreen", treetent)
AddPrefabPostInit("evergreen_normal", treetent)
AddPrefabPostInit("evergreen_tall", treetent)
AddPrefabPostInit("evergreen_short", treetent)
AddPrefabPostInit("evergreen_sparse", treetent)
AddPrefabPostInit("evergreen_sparse_normal", treetent)
AddPrefabPostInit("evergreen_sparse_tall", treetent)
AddPrefabPostInit("evergreen_sparse_short", treetent)

--spider in rock spawner
local function bolderspider(inst)
	inst:ListenForEvent("worked", function(inst)
		if math.random(7)==1 then
			if GetPlayer().components.talker then
				GetPlayer().components.talker:Say"He was hiding under there!"
			end
			local temp=math.random(2)
			if temp == 1 then
				spawnattacker("spider_spitter", true, 2, false, 4, true, inst)
			end
			if temp == 2 then
--function spawnattacker(prefab, trytoscale, chancetoscale, trytomega, chancetomega, teleporttoinst, inst)
				spawnattacker("spider_hider", true, 2, false, 4, true, inst)
			end
		end
	end)
end
AddPrefabPostInit("rock1", bolderspider)
AddPrefabPostInit("rock2", bolderspider)
AddPrefabPostInit("rock_flintless", bolderrocky)
AddPrefabPostInit("cave_entrance", bolderrocky)

--ghost spawner
local ghostsetv = Health.SetVal
function Health:SetVal(val, cause)
	local asdf = ghostsetv(self, val, cause)
		if self.currenthealth <= 0 and self.inst.prefab ~= "ghost" and self.inst.prefab ~= "eyeplant" and self.inst.prefab ~= GetPlayer().prefab and math.random(2) == 1 then
--function spawnattacker(prefab, trytoscale, chancetoscale, trytomega, chancetomega, teleporttoinst, inst)
			spawnattacker("ghost", false, 2, false, 4, true, self.inst)
		end
	return asdf
end

--sanity dropper
AddSimPostInit(function(inst)
	if GetPlayer().prefab and GetPlayer().components.sanity.dapperness then
		GetPlayer().components.sanity.dapperness = -TUNING.DAPPERNESS_HUGE
	end
end)

--sanity debuffs:
--tools:mouse click
local Tool = require "components/tool"
local mytool = Tool.CanDoAction
function Tool:CanDoAction(action)
	local asdf = mytool(self, action)
		if GetPlayer().components.sanity then
			local sanity=GetPlayer().components.sanity.current/GetPlayer().components.sanity.max
			if sanity < .66 then
--print(GetPlayer().prefab .. " refuses to work.")
				return false
			end
		end
	return asdf
end
--tools:spacebar
ACTIONS = GLOBAL.ACTIONS
local Workable = require "components/workable"
local myworkable = Workable.IsActionValid
function Workable:IsActionValid(action, right)
	local asdf = myworkable(self, action, right)
		if GetPlayer().components.sanity then
			local sanity=GetPlayer().components.sanity.current/GetPlayer().components.sanity.max
			if sanity < .66 then
--print(GetPlayer().prefab .. " refuses to work.")
				return false
			end
		end
	return asdf
end
--pickables:spacebar
local Pickable = require "components/pickable"
local mypickablespacebar = Pickable.CanBePicked
function Pickable:CanBePicked()
	local asdf = mypickablespacebar(self)
		if GetPlayer().components.sanity then
			local sanity=GetPlayer().components.sanity.current/GetPlayer().components.sanity.max
			if sanity < .25 then
--print(GetPlayer().prefab .. " refuses to work.")
				return false
			end
		end
	return asdf
end
--pickables:mouse click
local mypickablemouse = Pickable.CollectSceneActions
function Pickable:CollectSceneActions(doer, actions)
	local asdf = mypickablemouse(self, doer, actions)
		if GetPlayer().components.sanity then
			local sanity=GetPlayer().components.sanity.current/GetPlayer().components.sanity.max
			if sanity < .25 then
--print(GetPlayer().prefab .. " refuses to work.")
				table.remove(actions)
			end
		end
	return asdf
end

--reset map at start of new day
AddSimPostInit(function(inst)
	GLOBAL.GetWorld():ListenForEvent("daycomplete", function(inst)
		local map = TheSim:FindFirstEntityWithTag("minimap")
		if map then
			map.MiniMap:ClearRevealedAreas(true)
			GLOBAL.GetWorld():DoTaskInTime(1, function(inst)
				map.MiniMap:ClearRevealedAreas(false)
			end)
		end
	end)
end)

--nerf inventory size
AddSimPostInit(function(inst)
	GLOBAL.GetPlayer().components.inventory:DropEverything(false,true)
	GLOBAL.GetPlayer().components.inventory.maxslots=7
	GLOBAL.GetPlayer().HUD.controls.inv.bg:SetScale(.62,1,1)
	GLOBAL.GetPlayer().HUD.controls.inv.bgcover:SetScale(.62,1,1)
end)

--debug tools
--[[
require("debugkeys")
AddSimPostInit(function(player)
	GLOBAL.TheInput:AddKeyDownHandler(GLOBAL.KEY_T, function(down)
		local sanitypc=GetPlayer().components.sanity.max/2
		sanitypc = sanitypc-1
		GetPlayer().components.sanity.current=sanitypc
		GetPlayer().isbleeding = true
		GetPlayer().components.health:DoDelta(-1, false, "noneya", true)
	end)
end)
AddSimPostInit(function(player)
	GLOBAL.TheInput:AddKeyDownHandler(GLOBAL.KEY_R, function(down)
		local sanitypc=GetPlayer().components.sanity.max/2
		sanitypc = sanitypc+1
		GetPlayer().components.sanity.current=sanitypc
		GetPlayer().components.health:DoDelta(1, false, "noneya", true)
	end)
end)
--]]
